//"diag.sci","Diagnostyka - funkcje",12001,0,1.0.3,SYSTEM
//"System",2400,14,62
//////////////////////////////////////////////////////////////////////
// Diagnostyka - funkcje
// diag.sci

str.wydruk(0,-1,0)
strona 50,100,50,100

int plik, iVer, plikSum, plikAT, plikSummTmp
plikSum = 0
plikAT = 0
plikSummTmp = 0
int err, ShErrMsg

// zmienne rozrniajce dokumenty

int answers(1)
string sDialogTitle,sNoRepair,sErrRepair,sRepaired,sAskRepair

string StageDescT(1)
int StageT(1)
string RaportDescT(1)

string sKodFirmy = ""
string sFileName

string sFileNameCSV = ""

if len(arg4) > 0 then
	sFileNameCSV = arg4 + "\\WeryfikacjaPrzedMigracja.csv"
endif

sRepaired=" - NAPRAWIONO\n"
sNoRepair=" - NIE NAPRAWIONO\n"
sDialogTitle = "Diagnostyka bazy "
sAskRepair = ". Czy naprawi?"

record ProgressCounter
	long all,curr,last,new
	int sub Reset( long a )
		if !a then a=1
		all=a : curr = last = 0
		WriteStatusBar("")
	endsub
	int sub NextOne()
		curr+=1 : new = (curr*100)/all
		if new>last then last = new
		if last>100 then last = 100 : curr=all
		WriteStatusBar(using "=%d%%%%",last)
	endsub
endrec

ProgressCounter progress

#define NUM_CONT		0
#define NUM_YEAR		1
#define NUM_MONTH		2
#define NUM_DAYofYEAR	3
#define BIG_YEAR		2200
#define SER_OFFSET		0
#define PER_OFFSET		30000
#define FEBRUARY        2
#define PP_POCZ_ROK_OBR 1125        //Data pocztku roku obrachunkowego
#define TYPzzPRAWO			32	//rekord typu prawo uytkownika 0x20
#define BAS_KH  0x14
#define BAS_PR  0x06
#define IDkhFIRMA               1
#define XTustaDOK       "32"  // typ dokumentu

// *************   funkcje  *****************

String VMarker = "WeryfikacjaPrzedMigracja"		// oznaczenie weryfikacji przed migracja

String Sub GetVMarker()
	GetVMarker = VMarker
EndSub

Int Sub EnabledVMarker()
	EnabledVMarker = (arg5 == GetVMarker())
EndSub

Long   VError  = 0								// VerificationErrorCounter

Long Sub IncreaseVError( Long increaseValue )
	If EnabledVMarker() Then VError += increaseValue
	IncreaseVError = VError
EndSub

Long Sub GetVError()
	GetVError = VError
EndSub

string sub DataiCzas()
	date dtTmp
	dtTmp.TodayTime()
	String strTmp = dtTmp.DateToStr()
	Buf = strTmp
	Replace "-", ""
	Replace "-", ""
	Replace " ", ""
	Replace ":", ""
	Replace ":", ""
	DataiCzas = Buf
endsub

string sub NazwaPliku()
	Buf = NAZWA_PLIKU
	Replace ".TXT", ""
	NazwaPliku = Buf
endsub

#define TiFactory		0x2A00
#define	TiAutoTestParams	0x2E50

int Sub NoUserInteraction()
	Dispatch xReportExecuteParams = GetExecuteParams()
	if (xReportExecuteParams.objId == TiFactory) then
		NoUserInteraction = 0
	else
		NoUserInteraction = 1
	EndIf
EndSub

int sub OpenBase( string bas )
	OpenBase = open KatalogFirmy() + "51" + bas + ".dat" for base bas
	BaseError(OpenBase,4)
endsub

int sub OpenBaseB( BaseAll baza, string bas )
	if baza.SetBase(bas) then error "Nie mona otworzy bazy "+bas
	OpenBaseB = baza.Open()
endsub

//-------------------------------------------------------------------------
int sub OpenBaseWzor( string bas )	//otwiera baz wzorcow
	string strPrefix = "AM"+firma.code
	
	OpenBaseWzor = open KatalogBazWzor() + strPrefix + "51" + bas + ".dat" for base bas
	BaseError(OpenBaseWzor,4)
endsub
//--------------------------------------------------------------------------

int sub TextOut(string s)
	if (plikSum <= 0) then
		print #plik;s;lf
	Else
		print #plikSum;s;lf
	EndIf
	print s;lf
endsub

int plikCSV = 0

int sub TextOutToCSV(int errCode, string errMessage)
	if (plikCSV > 0) then
		print #plikCSV;(using "%s;%l;%s", GetReportName(),errCode, errMessage);lf
	EndIf
endsub


int sub InsertRec(int bas,string b)
	int err
	err=InsRec(bas)
	if err then
		TextOut(using " - NIE NAPRAWIONO: Bd wstawiania nowego rekordu do bazy %s (%d)\n",b,err)
	else
		TextOut(sRepaired)
	endif
	InsertRec=err
endsub

int sub InsertRecB(BaseAll baza)
	int err
	err=baza.Insert()
	if err then
		TextOut(using " - NIE NAPRAWIONO: Bd wstawiania nowego rekordu do bazy %s (%d)\n",baza.GetBaseName(),err)
	else
		TextOut(sRepaired)
	endif
	InsertRecB=err
endsub


int sub DeleteRec(int bas,string b)
	int err
	err=DelRec(bas)
	if err then
		TextOut(using " - NIE USUNITO: bd usuwania rekordu z bazy %s (%d)\n",b,err)
	else
		TextOut(" - USUNITO\n")
	endif
	DeleteRec=err
endsub

int sub DeleteRecB(BaseAll baza)
	int err
	err=baza.Delete()
	if err then
		TextOut(using " - NIE USUNITO: bd usuwania rekordu z bazy %s (%d)\n",baza.GetBaseName(),err)
	else
		TextOut(" - USUNITO\n")
	endif
	DeleteRecB=err
endsub


int sub UpdateRec(int bas,string b)
	int err
	err=PutRec(bas)
	if err then
		TextOut(using " - NIE NAPRAWIONO: Bd zapisu do bazy %s (%d)\n",b,err)
	else
		TextOut(sRepaired)
	endif
	UpdateRec=err
endsub

int sub UpdateRecB(BaseAll baza)
	int err
	err=baza.Update()
	if err then
		TextOut(using " - NIE NAPRAWIONO: Bd zapisu do bazy %s (%d)\n",baza.GetBaseName(),err)
	else
		TextOut(sRepaired)
	endif
	UpdateRecB=err
endsub

string sub FirmaKod()
	BaseKH basKH
	if sKodFirmy == "" then
		if ( basKH.Open() ) then 
			Error "Bd otwarcia bazy KH"
		endif
		basKH.SetKey("id")
		basKH.SetKeySeg("id", 1)
		if basKH.GetRec(EQ) then 
			Error "Nie mog pobra rekordu z bazy KH"
		endif
		sKodFirmy = basKH.GetField("kod")
		basKH.Close()
	endif
	FirmaKod = sKodFirmy
endsub

int sub AskMain(int pyt)
	int ask_temp
	If IncreaseVError(1) Then AskMain = 0 : Exit
	if pyt>size(answers) then grow answers, pyt-size(answers)
	if !pyt then delete regular " check/=/(/&Zastosuj dla wszystkich/)"
	AskMain=0
	
	if pyt then AskMain=answers(pyt)
	if !ShErrMsg && !AskMain then
		ask_temp = Message(using buf,sDialogTitle)
		select case ask_temp
			case 2,18
				TextOut("\n\n\nPrzerwano...\n")
				End				
			case else
				if ask_temp>=16 then ask_temp-=16 : answers(pyt)=ask_temp
				AskMain=ask_temp
		endselect
	endif
	if AskMain==3 then AskMain=0
	if ShErrMsg then AskMain=0
endsub

int sub Ask( int pyt, string s )
	buf = s
	Arg "%", "%%"
	Replace Arg
	Delete Arg
	buf += "{{icon=? buttons=[N&apraw:o](&Nie naprawiaj:p)(&Przerwij:a) check=(&Zastosuj dla wszystkich) title=(%s)}}"
	Ask =  AskMain(pyt)
endsub

int sub Ask2( int pyt, string s, string buttons )
	buf = s
	Arg "%", "%%"
	Replace Arg
	Delete Arg
	buf += "{{icon=? buttons="+buttons+" check=(&Zastosuj dla wszystkich) title=(%s)}}"
	Ask2 =  AskMain(pyt)
endsub

int sub AskOkEnd( int pyt, string s )
	buf = s
	Arg "%", "%%"
	Replace Arg
	Delete Arg
	buf += "{{icon=? buttons=[&Dalej:o](&Przerwij:a) check=(&Zastosuj dla wszystkich) title=(%s)}}"
	AskOkEnd =  AskMain(pyt)
endsub

int sub TextOutAskOkEnd( int pyt, string t )
	TextOut(t)
	TextOutToCSV(pyt, t)
	AskOkEnd(pyt,t)
endsub


int sub TextOutAndAsk( int n, string t, string a )
	TextOut(t)
	TextOutToCSV(n, t)
	TextOutAndAsk = Ask(n,t+a)
endsub

int sub TextOutAndAsk2( int n, string t, string a, string buttons )
	TextOut(t)
	TextOutToCSV(n, t)
	TextOutAndAsk2 = Ask2(n,t+a, buttons)
endsub


int sub TextOutAndAsk3( int n, string t )
	TextOut(t)
	TextOutToCSV(n, t)
	TextOutAndAsk3 = Ask(n,t+sAskRepair)
endsub


int sub ShowFileInfo()
	if (plikSum) then
		Close plikSum
		plikSum = 0
	else
		print using "\n\n Powysze podsumowanie zostao zapisane w katalogu %s do pliku %s\n",KatalogLog(),sFileName
	EndIf
endsub


int SUB UsunRekord_0(string b)	// funkcja usuwa z danej bazy rekord o id = 0
	int bas 
	IF Len(b) == 3 THEN
		bas = open KatalogFirmy() + "5" + b + ".dat" for base b
		BaseError(bas,4)
	ELSE
		bas = open KatalogFirmy() + "51" + b + ".dat" for base b
		BaseError(bas,4)
	ENDIF

	SetKey(bas, "id")
	SetKeySeg(bas, "id", 0)
	IF !GetRec(bas, EQ) THEN
		IF TextOutAndAsk(7,"W biecej bazie wykryto rekord o id = 0", ". Czy usun ten rekord ?") THEN
			IF !DelRec(bas) THEN
				TextOut(" - USUNITO.\n")
			ELSE
				TextOut(" - NIE MONA USUN REKORDU.\n")
			ENDIF
		ELSE
			TextOut( sNoRepair )
		ENDIF
	ENDIF
	Close (bas)	
ENDSUB

// ------------- wybr etapw --------------------------

int sub StageAddDesc( string s )
	if RaportDescT(1) then grow RaportDescT,1
	RaportDescT(size(RaportDescT)) = s
endsub

int sub StageAddStage( string s )
	if StageDescT(1) then grow StageDescT,1
	StageDescT(size(StageDescT)) = s
endsub

int sub A_ChooseStages( int szer )
	int curry
	int chkwys=40
	grow StageT,size(StageDescT)-1
	for err=1 to err>size(stageT)
		if StageDescT(err)!="X" then chkwys+=20
	next err
	form GetReportName(),szer,size(RaportDescT)*15+chkwys+98
		curry=5
		for err=1 to !RaportDescT(1) || err>size(RaportDescT)
			Text RaportDescT(err),10,curry,szer-20,15
			curry+=15
		next err

		buf = GetIni( GetReportName(),"Etapy" )
		ShErrMsg = Val(GetIni( GetReportName(), "Nie wywietlaj komunikatw o bdach"))
		if !buf || len(buf)<size(StageT) then buf=Pattern(size(StageT),"1")
		for err=1 to err>size(stageT)
			if buf(err)!='0' then stageT(err)=1
		next err
		curry+=10
		Group "",5,curry,szer-15,18+chkwys
		curry+=12
		for err=1 to !StageDescT(1) || err>size(StageDescT)
			if StageDescT(err)!="X" then
				ChkBox StageDescT(err),StageT(err),10,curry,szer-25,20
				curry+=20
			endif
		next err
		curry+=20
		ChkBox "Nie wywietlaj komunikatw o bdach",ShErrMsg,10,curry,szer-25,20
		curry+=20

		button "&Kontynuuj",szer-200,curry+15,80,25,2
		button "&Przerwij",szer-100,curry+15,80,25,-2
If !EnabledVMarker() Then
	if execform != 2 then error ""
Else
	ShErrMsg=0
EndIf
	buf=""
	for err=1 to err>size(stageT)
		buf+=iif(StageT(err)==0,"0","1")
	next err
	PutIni(GetReportName(),"Etapy",buf)
	PutIni(GetReportName(),"Nie wywietlaj komunikatw o bdach", using "%d",ShErrMsg)
endsub

int sub ChooseStages( int szer )

	if (NoUserInteraction()) then
		grow StageT,size(StageDescT)-1
		buf = GetIni( GetReportName(),"Etapy" )
		ShErrMsg = 1
		buf = ""
		for err=1 to err>size(stageT)
			buf+="1"
		next err
		if !buf || len(buf)<size(StageT) then buf=Pattern(size(StageT),"1")
		for err=1 to err>size(stageT)
			if buf(err)!='0' then stageT(err)=1
		next err
	else
		ChooseStages = A_ChooseStages(szer)
	endIf
EndSub


int sub StageSummary( int st_Num )
	int wdt = (str.szer/TextWidth( "X" ))-2
	if StageT( st_Num ) && StageDescT(st_Num)!="X" then
		buf = "--- Zakoczono '"+StageDescT(st_Num)+"' "
		if len(buf)<wdt then buf+=Pattern(wdt-len(buf),"-")
		buf+="\n"
		TextOut(buf)
	endif
endsub

int MonthDays(13) = 0,  31,  59,  90, 120, 151, 181, 212, 243, 273, 304, 334, 365
string PoczRokuObr = ""

string Sub UstalPoczRokuObr()
baseAll zzpom

	if PoczRokuObr == "" then
		OpenBaseB(zzpom,"ZZ")
		zzpom.SetKey("CROSS1")
		zzpom.SetKeySeg("typi",TYPzzPRAWO)
		zzpom.SetKeySeg("baza1",BAS_KH)
		zzpom.SetKeySeg("id1",IDkhFIRMA)
		zzpom.SetKeySeg("baza2",BAS_PR)
		zzpom.SetKeySeg("id2",PP_POCZ_ROK_OBR)
		if !zzpom.GetRec(EQ) then
			PoczRokuObr = zzpom.GetField("termin")
		else
		  PoczRokuObr = "1998-01-01"
		endif
		zzpom.close()
	endif
EndSub

int Sub IsItLeapYear(int nYear)
	IsItLeapYear =  iif(( (!(nYear % 4) && (nYear % 100)) || !((nYear + 400) % 400) ),1,0)
EndSub

int Sub DayOfYear(string ddata)
int day,month,year

	buf = ddata
	find regular "{:d##}/-{:d##}{:d##}"
	year = 	val(regular 1)
	month = val(regular 2)
	day = 	val(regular 3)
	DayOfYear = day + MonthDays(month-1) + iif((month > FEBRUARY),IsItLeapYear(year),0)
EndSub

int Sub OkresNumeracji(string seria, string TypDk, string ddate)
string ddata, dtPocz
int nLata=0
int day,month,year
int PoczDay,PoczMonth
int numeracja
baseAll xtpom

	OpenBaseB(xtpom,"XT")
	xtpom.SetKey("kod")
	xtpom.SetKeySeg("typi",val(XTustaDOK))
	xtpom.SetKeySeg("kod",TypDk)
	if !xtpom.GetRec(GE) && xtpom.GetField("typi")==val(XTustaDOK) && xtpom.GetField("kod")==TypDk then
		TypDk = using "%d",xtpom.GetField("id")
	else
	  TypDk = "0"
	endif

	xtpom.SetKey("super")
	xtpom.SetKeySeg("super",val(TypDk))
	xtpom.SetKeySeg("kod",seria)
	if !xtpom.GetRec(GE) && xtpom.GetField("super")==val(TypDk) && xtpom.GetField("kod")==seria then
		numeracja = xtpom.GetField("long")
	else
	  numeracja = -1
	endif

	xtpom.close()

	if ddate == "" then
		ddata = Data()
	else
		ddata = ddate
	endif
	
	buf = ddata
	find regular "{:d##}/-{:d##}/-{:d##}"
	year = 	val(regular 1)
	month = val(regular 2)
	day = 	val(regular 3)

	UstalPoczRokuObr()
	buf = PoczRokuObr
	find regular ":d##/-{:d##}/-{:d##}"
	PoczMonth = val(regular 1)
	PoczDay = 	val(regular 2)

	select case ( numeracja )
		case NUM_CONT
			OkresNumeracji = (BIG_YEAR + PER_OFFSET)
		
		case NUM_YEAR
			if month > PoczMonth then
		    OkresNumeracji = (year + PER_OFFSET)
			else
				if (month == PoczMonth) && (day >= PoczDay) then
					OkresNumeracji = (year + PER_OFFSET)
				else
					OkresNumeracji = (year - 1 + PER_OFFSET)
				endif
			endif

		case NUM_MONTH
			OkresNumeracji = (((year - 1996)*12 + month) + PER_OFFSET)

		case NUM_DAYofYEAR
			nLata = year - 1996
			OkresNumeracji = (366*nLata + DayOfYear(ddata))

		case Else
			OkresNumeracji = 1
	endselect
EndSub

int Sub OpenFileForAppend(string sFileName, string headerText)

	if len(headerText) > 0 && !find file sFileName then
		OpenFileForAppend = open sFileName for OUTPUT

		print # OpenFileForAppend; headerText; LF

		close OpenFileForAppend
		OpenFileForAppend = 0
	endif

	string sTmpFileName = sFileName + "$"
	int plikTmp = open sTmpFileName for OUTPUT

	Append sFileName to plikTmp
	Close plikTmp

	OpenFileForAppend = open sFileName for OUTPUT
	Append sTmpFileName to OpenFileForAppend

	delete file sTmpFileName
EndSub

//******************************

select case firma.code
	case "HM"
		iVer = 3
	case "FP"
		iVer = 2
	case "HL","FL"
		iVer = 1
endselect

sFileName = using "%s_%s_%s.TXT", FirmaKod(), NazwaPliku(), DataiCzas()

if sRaportDescription then
If !EnabledVMarker() Then
	err =Message(sRaportDescription+"{{icon=i buttons=[&Kontynuuj:o](&Przerwij:a) check=(&Nie wywietlaj komunikatw o bdach) }}")
	if (2 == err) || (18 == err) then error ""
	if 17 == err then
		ShErrMsg = 1
	else
		ShErrMsg = 0
	endif
Else
	ShErrMsg=0
EndIf
endif

Dispatch xReportExecuteParams = GetExecuteParams()
if (!plikSum && (TiAutoTestParams == xReportExecuteParams.objId)) then
	if (Len(xReportExecuteParams.summaFileName) > 0) then
		plikSummTmp=open KatalogLog()+xReportExecuteParams.summaFileName+"$" for output
		Append KatalogLog()+xReportExecuteParams.summaFileName to plikSummTmp
		Close plikSummTmp
		plikSum = open KatalogLog()+xReportExecuteParams.summaFileName for OUTPUT
		Append KatalogLog()+xReportExecuteParams.summaFileName+"$" to plikSum
	EndIf
EndIf

if (!plikSum) then
	plik=open KatalogLog()+sFileName for Output
	if plik<=0 then Message "Nie mog utworzy pliku "+sFileName+" z podsumowaniem\n" : error ""
EndIf

if (len(sFileNameCSV) > 0) then
	plikCSV = OpenFileForAppend(sFileNameCSV, "Diagnostyka;Nr bdu;Opis bdu")
endif

// "Bdne daty dokumentw -weryfikacja przed migracj"
String sVerifyMaxDate = "3000-12-31"
